#!/usr/bin/python
################################################################################
# Marko Grnroos <magi@iki.fi>, 2003
#
# Examines differences between two OpenOffice localization files.
################################################################################

import os,sys,re,string

if len(sys.argv) != 3:
    print "Usage: erot.py <original> <modified>"
    sys.exit (1)

filename1 = sys.argv[1]
filename2 = sys.argv[2]

def readfile (filename):
    english = []
    finnish = {}
    prev    = ""

    sys.stderr.write ("Reading %s...\n" % filename)
    fin = open (filename, "r")
    line = fin.readline ()
    while line:
        fields = string.split (line, "\t")

        if len(fields) > 10:
            key = "%s %s %s %s %s %s %s %s %s" % (fields[0], fields[1], fields[2], fields[3], fields[4], fields[5], fields[6], fields[7], fields[8])
            value = fields[10]
            if value == "-":
                value = value + " : " + fields[12]

            if int(fields[9]) == 1:
                english.append ((key, value, line))
            else:
                if 0 and finnish.has_key (key):
                    sys.stderr.write ("Double key: %s, language %s\n" % (key, fields[9]))
                    sys.stderr.write (prev +"\n")
                    sys.stderr.write (line+"\n")
                    sys.exit (1)
                    
                finnish[prev] = value

        prev = line
        line = fin.readline ()

    fin.close ()

    return (english, finnish)

en_list1, fi_map1 = readfile (filename1)
en_list2, fi_map2 = readfile (filename2)


print "<title>Erot</title>"
print "Raportti alkuperisen ja muokatun merkkijonotiedoston eroista.<p>"
print "Muokatut vrjtty sinisell, uudet keltaisella. \"Uudeksi\" on tss tulkittu sellainen, jossa englanninkielinen ja \"knnetty\" merkkijono ovat samat (ei ole aina ptev tapa). Jos ne ovat samat, on mys \"alkuperinen\"-teksti jtetty tyhjksi.<p>"
print "\"Alkuperinen\" suomenkielinen merkkijono voi nky englanninkielisen, jos englanninkielinen merkkijono on jo ehtinyt vaihtua jossain kohtaa alkuperisest.<p>"
print "<html><table width=\"100%\"border=2><TR><th>Mod</th><th>English</th><th>Finnish (original)</th><th>Finnish (new/changed)</th></tr>"
for item in en_list1:
    (key, english, line) = item

    module = string.split (key) [0]

    if fi_map1.has_key (line):
        fi_orig = fi_map1 [line]

        if fi_map2.has_key (line):
            fi_new = fi_map2 [line]

            if fi_orig != fi_new:
                color = "#f0f0ff"
                if english == fi_orig:
                    fi_orig = ""
                    color = "#ffffe0"

                #sys.stderr.write ("Orig = %s\n" % fi_orig)
                try:
                    fi_orig = fi_orig.decode("utf-8").encode("iso-8859-1")
                except UnicodeError:
                    pass

                try:
                    fi_new = fi_new.decode("utf-8").encode("iso-8859-1")
                except UnicodeError:
                    pass
                
                print "<tr valign=top><td>%s</td><td>%s</td><td>%s</td><td bgcolor='%s'>%s</td></tr>" % (module, english, fi_orig, color, fi_new)
print "</table></html>"

    
