#!/usr/bin/perl
# ****************************************************************************
#
#    Copyright (C) 2002 Matja"z Godec <gody@agenda.si>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#****************************************************************************
#

if ($#ARGV !=1) {
	die "Usage:  $0 inputfile version\n";
}


#--#
# You have to translate fields 11, 13 and 14.
# Field 12 is obsolete!
# In OOo1.0.2 there is 222 entries in field 13 and 22 entries in field 14.
# Not much, but let's keep all together for new releases, if something changes.
#--#

#--#
# Some settings
# Last lines depends on this number. You can get it by
# counting lines in output.txt (devide with 2, if you have 
# strings for lang 01 and lang 99 in there)!
#$expected = 20691;	# strings to translate in OOo 1.0.1 (and 1.0.2)
$expected = 21205;

#--#

#--#
# Take two arguments: input file (output of localize, often called output.txt)
# and our version.

sub esc_char {
	my $text = shift @_ ;
#	$text =~ s/\"/\\\"/g;
#	$text =~ s/\'/\\\'/g;
	return $text ;
}


$infile=$ARGV[0] ;
$version=$ARGV[1];

# Some numbers for stats

$a=0;			# fields 13 and 14 empty
$b=0;			# field 14 empty
$c=0;			# field 13 empty
$d=0;			# fields 13 and 14 NOT empty

# For OOo1.0.2 these numbers are:
# a=20459
# b=222
# c=10
# d=0
# $expected = 20691



# Make three directories.
# In 'work' are files that should be translated.
# In other two directories we keep files for merging back translated PO files

$outdir=$version."-extract" ;
$outdir1=$version."-oo" ;
$outdir2=$version."-work" ;

mkdir $outdir ;
mkdir $outdir1 ;
mkdir $outdir2 ;

# Procedure for printing header in every new PO file
# Data like Language-team, date, Encoding... can be updated later
# (i.e. when translating - Kbabel has such an option)

sub print_header {

	print OUT ( "msgid \"\"\n" ) ;
	print OUT ( "msgstr \"\"\n" ) ;
	print OUT ( "\"\"\n" ) ;
	print OUT ( "\"Last-Translator: \\n\"\n" ) ;
	print OUT ( "\"PO-Revision-Date: 2002-10-04 14:16+0200\\n\"\n" );
	print OUT ( "\"Language-Team:  <sl@li.org>\\n\"\n" );
	print OUT ( "\"Content-Type: text/plain; charset=UTF-8\\n\"\n" );
	print OUT ( "\"Content-Transfer-Encoding: 8bit\\n\"\n" );
	print OUT ( "\"X-Generator: KBabel 0.9.6\\n\"\n" );

	print OUT2 ( "msgid \"\"\n" ) ;
	print OUT2 ( "msgstr \"\"\n" ) ;
	print OUT2 ( "\"\"\n" ) ;
	print OUT2 ( "\"Last-Translator: \\n\"\n" ) ;
	print OUT2 ( "\"PO-Revision-Date: 2002-10-04 14:16+0200\\n\"\n" );
	print OUT2 ( "\"Language-Team:  <sl@li.org>\\n\"\n" );
	print OUT2 ( "\"Content-Type: text/plain; charset=UTF-8\\n\"\n" );
	print OUT2 ( "\"Content-Transfer-Encoding: 8bit\\n\"\n" );
	print OUT2 ( "\"X-Generator: KBabel 0.9.6\\n\"\n" );
}

# sekcija (section) is name of the OOo module (first column in output.txt)
# datoteka (file) is PO file to write msg strings to

$sekcija = "qq" ;
$datoteka = "qq";

open ( INP0 , "$infile" ) || die "There is no file named: $infile $!" ;
#open INP0 , "$infile";
while (<INP0>) {
	
	# read one line and split it in an array named $original
	# make PO files named by OO module (sekcija) like basic.po, basctl.po etc.
	$ooline = $_ ;
	@original = split ( /\t/ );
	if ( $original[0] ne $sekcija ) {
		$sekcija = $original[0] ;
		print ( "\n$sekcija" ) ;
		close OUT ;
		close OUT1 ;
		close OUT2 ;
		open OUT , ">$outdir"."/".$sekcija.".po" ;
		open OUT1 , ">$outdir1"."/".$sekcija.".oo" ;
		open OUT2 , ">$outdir2"."/".$sekcija.".po" ;
		print_header ;
	}

	# temp in example: 
	# replaces "source\basicide\basidesh.sr"c with "source_basicide_basidesh.src"
	$temp = $original[1] ;
	$temp =~ s/\\/_/g;

	if ( $temp ne $datoteka ) {
		$datoteka = $temp ;
	}
	
	# print dots so we can see it's doing something
	print ( "." ) ;

	# prevedena (translated)
	$prevedena = <INP0> ;

	#prevod (translation)
	@prevod = split ( /\t/ , $prevedena );

# Mark comments with "##" so we can skip them in merge script! Here
# we keep some info about position of our string.
# This is important because in comments with one "#" we write info
# about fields 13 and 14! We don't wanna have empty msgid/msgstr pairs in our
# PO file, because they are treated as untranslated in Kbabel!

	print OUT "##" ;
	print OUT2 "##" ;
	for ($i = 1; $i<=5; $i++ ) {
		$lastitem = $original[$i] ;
		$lastitem =~ s/\s+//g ;
		print OUT " $lastitem" if ( $lastitem ) ;
		print OUT2 " $lastitem" if ( $lastitem ) ;
	}
	print OUT "\n" ;
	print OUT2 "\n" ;

#--#
# Now the real show begins.
# In "#" comment we write a string that in most cases looks like:
# "A0B0" and means: fields 13 and 14 are empty so we don't need to make msgid/msgstr pairs!
# Logicaly, "A1B0" means that there is some text in field 13 and none in field 14.
# Complicated but simple.
# Skip field 12, which is obsolete.
#--#

	$our_comment = "ERROR_IN_IF";
	if ( "$original[12]" eq "" && "$original[13]" eq "" ) {
		$our_comment = "A0B0";		# String for comment
		$msgid=$original[10];		# String for msgid
                #
		# Escape special character " 
		#                                #
		$msgid = esc_char ( $msgid );
		++ $a;				# For stats
		print OUT "# $our_comment\n" ;	# Write comment in output files
		print OUT2 "# $our_comment\n" ;
		print OUT ( "msgid \"$msgid\"\n" ) ;	# Write actual lines
		print OUT ( "msgstr \"\"\n" ) ;		# in output files
#		print OUT "\n" ;
		print OUT2 ( "msgid \"$msgid\"\n" ) ;
		print OUT2 ( "msgstr \"\"\n" ) ;
#		print OUT2 "\n" ;

				# The same way make the rest
				# just be careful about number of msgid/msgstr
	}
	elsif ( "$original[12]" ne "" && "$original[13]" eq "" ) {
		$our_comment = "A1B0";
		$msgid=$original[10];
		$msgid = esc_char ( $msgid );
		$msgidA = $original[12];
		$msgidA = esc_char ( $msgidA );
		$b++;
		print OUT "# $our_comment\n" ;
		print OUT2 "# $our_comment\n" ;

		print OUT ( "msgid \"$msgid\"\n" ) ;
		print OUT ( "msgstr \"\"\n" ) ;
#		print OUT "\n" ;
		print OUT ( "msgid \"$msgidA\"\n" ) ;
		print OUT ( "msgstr \"\"\n" ) ;
#		print OUT "\n" ;

		print OUT2 ( "msgid \"$msgid\"\n" ) ;
		print OUT2 ( "msgstr \"\"\n" ) ;
#		print OUT2 "\n" ;
		print OUT2 ( "msgid \"$msgidA\"\n" ) ;
		print OUT2 ( "msgstr \"\"\n" ) ;
#		print OUT2 "\n" ;

	}
	elsif ( "$original[12]" eq "" && "$original[13]" ne "" ) {
		$our_comment = "A0B1";
		$msgid = $original[10];
		$msgid = esc_char ( $msgid );
		$msgidB = $original[13];
		$msgidB = esc_char ( $msgidB );
		$c++;
		print OUT "# $our_comment\n" ;
		print OUT2 "# $our_comment\n" ;

		print OUT ( "msgid \"$msgid\"\n" ) ;
		print OUT ( "msgstr \"\"\n" ) ;
#		print OUT "\n" ;
		print OUT ( "msgid \"$msgidB\"\n" ) ;
		print OUT ( "msgstr \"\"\n" ) ;
#		print OUT "\n" ;

		print OUT2 ( "msgid \"$msgid\"\n" ) ;
		print OUT2 ( "msgstr \"\"\n" ) ;
#		print OUT2 "\n" ;
		print OUT2 ( "msgid \"$msgidB\"\n" ) ;
		print OUT2 ( "msgstr \"\"\n" ) ;
#		print OUT2 "\n" ;
	}
	elsif ( "$original[12]" ne "" && "$original[13]" ne "" ) {
		$our_comment = "A1B1";
		$msgid = $original[10];
                $msgid = esc_char ( $msgid );
		$msgidA=$original[12];
                $msgidA = esc_char ( $msgidA );
		$msgidB=$original[13];
                $msgidB = esc_char ( $msgidB );
		$d++;
		print OUT "# $our_comment\n" ;
		print OUT2 "# $our_comment\n" ;

		print OUT ( "msgid \"$msgid\"\n" ) ;
		print OUT ( "msgstr \"\"\n" ) ;
		print OUT "\n" ;

		print OUT ( "msgid \"$msgidA\"\n" ) ;
		print OUT ( "msgstr \"\"\n" ) ;
		print OUT "\n" ;

		print OUT ( "msgid \"$msgidB\"\n" ) ;
		print OUT ( "msgstr \"\"\n" ) ;
		print OUT "\n" ;

		print OUT2 ( "msgid \"$msgid\"\n" ) ;
		print OUT2 ( "msgstr \"\"\n" ) ;
		print OUT2 "\n" ;

		print OUT2 ( "msgid \"$msgidA\"\n" ) ;
		print OUT2 ( "msgstr \"\"\n" ) ;
		print OUT2 "\n" ;

		print OUT2 ( "msgid \"$msgidB\"\n" ) ;
		print OUT2 ( "msgstr \"\"\n" ) ;
		print OUT2 "\n" ;
	}

# Ufff, probably could be done easier but...
# it works (hope so :-)

	print OUT1 ( $ooline ) ;
	print OUT1 ( $prevedena ) ;
}

# Write some stats

print "\n" ;
print "\n" ;
print "Number of [fields 13 and 14 empty]:			$a\n";
print "Number of [field 14 empty, field 13 NOT empty]:		$b\n";
print "Number of [field 13 empty, field 14 NOT empty]:		$c\n";
print "Number of [fields 13 and 14 NOT empty]:			$d\n";
print "=================================================================\n";
$all = $a+$b+$c+$d;
print "All together:						$all\n";
print "\n" ;
if ( $expected == $all) {
	print "OOoOOoOOoOOoOOoOOoOOoOOoOOoOOoOOoOOoOOoOOoOOoOOoOOoOOoOOoOOoOOoOOo\n";
	print "\n";
	print "Hura, you did it! Wish you good luck translating.\n";
	print "Comments, critics...:\n";
	print "Robert Ludvik <r\@aufbix.org>\n";
	print "\n";
	print "OOoOOoOOoOOoOOoOOoOOoOOoOOoOOoOOoOOoOOoOOoOOoOOoOOoOOoOOoOOoOOoOOo\n";
}
else {
	print "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n";
	print "\n";
	print "The expected number of strings and the real one aren't equal!\n";
	print "Something went wrong. Mail me (you can AFTER you solve the problem ;-)\n";
	print "Robert Ludvik <r\@aufbix.org>\n";
	print "\n";
	print "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n";
}
close INP0;

