#!/usr/bin/perl
# ****************************************************************************
#
#    Copyright (C) 2003 Robert Ludvik <r@aufbix.org>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#****************************************************************************

#--#
# This file is called from a shell. For testing purposes
# you can run it with two arguments i.e.:
# "perl po2oo.pl basctl.oo basctl.po > t9n_basctl.oo"
#--#  

#--# Settings

$target_lng="35";	# Target language (field 10 of output.txt)
			# Change to your needs
			# For now this is the only setting

#--# End settings

$oofile=$ARGV[0] ;	# Reference OOo file
$pofile=$ARGV[1] ;	# PO file



#--#
# Make some cleaning
#--#
sub clean_text {
	my $text = shift @_ ;
	$text =~ s/^\s+//g;
	$text =~ s/^msgstr// ;
	$text =~ s/^\s+//g;
	$text =~ s/^"// ;
	$text =~ s/\n$//;
	$text =~ s/"$//;
	$text =~ s/\\"/"/g;
	return $text ;
}

open INP0 , "$oofile" ;
open INP2 , "$pofile" ;

#--#
# Discard headers
# Remember that you should not change a format of header 
# in the source (PO) files because number of this lines depends on that!
# Kbabel added two lines at begining of my translated files so
# I had to remove them!!!
# Just remember, that first comment "##" should begin in 10th line :-)
#--#

$txt = <INP2> ;
$txt = <INP2> ;
$txt = <INP2> ;
$txt = <INP2> ;
$txt = <INP2> ;
$txt = <INP2> ;
$txt = <INP2> ;
$txt = <INP2> ;
$txt = <INP2> ;	

while (<INP2>) {		
	#
	# Read PO file
	# Be careful on our "##" comments!!
	# In our bizzare files we use 'normal' (#) comments for info
	# and 'double' (##) comments for real one
	#
	$our_comment = $_;
	$our_comment =~ s/^#\s+//g;
	$our_comment =~ s/\n//g;
	#
	# Check out what the comment is and do a proper thing
	# Both fields (13 and 14) were empty ->
	# we have only one magid/msgstr pair for this line
	#
	if ( "$our_comment" eq "A0B0" ) {
		$text1 = <INP2> ;		# This is msgid
		$text1 = <INP2> ;	     	# This is msgstr
		#
		# This could be a procedure, because it works the same all the time
		# global variables etc. MISSED THAT CLASS!
		# Here we take an original line from $VERSION-oo/ folder 
		# and just replace appropriate field (in this case field 11 -
		# NOTE polja[10]). 
		# We do the samo for the other two type of comments
		# just be careful about order and number of msgid/msgstr pairs
		#
		$kartako = <INP0>;	# Original (lang 01)
		$ooline = <INP0>;	# Read OOo line (lang 99)
		@polja = split ( /\t/ , $ooline ) ;
		$polja[10] = clean_text ( $text1 ) ;
		$index = 0 ;
		$polja[9] = "$target_lng" ;
		#
		# Put all fields in one line, separated with TABs 
		# (except the first one (index)!)
		#
		foreach $polje (@polja) {
			if ( $index == 0 ) {
				$output = $polje ;
			} else {
				$output .= "\t" . $polje ;
			} ;
			$index ++ ;
		}
		print ( "$kartako" );
		print ( "$output" ) ;
	}
#
# And here we go again.
#
	elsif ( "$our_comment" eq "A1B0" ) {
		$text1 = <INP2> ;		# This is 1. msgid
		$text1 = <INP2> ;	     	# This is 1. msgstr
		$text11 = $text1;
		#
		# Our comment (A1B0) means that we have two msgid/msgstr pairs.
		# So we must again check for empty lines and comments
		# And then we get second msgid/msgstr pair
		#
		<INP2>;
		$text1 = <INP2> ;		# This is 2. msgid
		$text1 = <INP2> ;	     	# This is 2. msgstr
		$text12 = $text1;
		#
		# Split fields etc... already seen
		#
		$kartako = <INP0>;	# Original
		$ooline = <INP0>;	# Read OOo line
		@polja = split ( /\t/ , $ooline ) ;
		$polja[10] = clean_text ( $text11 ) ;
		$polja[12] = clean_text ( $text12 ) ;
		$index = 0 ;
		$polja[9] = "$target_lng" ;
		#
		# Put all fields in one line, separated with TABs 
		# (except the first one (index)!)
		#
		foreach $polje (@polja) {
			if ( $index == 0 ) {
				$output = $polje ;
			} else {
				$output .= "\t" . $polje ;
			} ;
			$index ++ ;
		}
		print ( "$kartako" );
		print ( "$output" ) ;
	}
#
# and again
#

	elsif ( "$our_comment" eq "A0B1" ) {
		$text1 = <INP2> ;		# This is 1. msgid
		$text1 = <INP2> ;	     	# This is 1. msgstr
		#
		# Our comment (A0B1) means that we have two msgid/msgstr pairs.
		# So we must again check for empty lines and comments
		#
		s/^\s+//g;
		next if ( /^##/ );
		next if ( $_ eq "" );
		#
		# And then we get second msgid/msgstr pair
		#
		<INP2>;
		$text2 = <INP2> ;		# This is 2. msgid
		$text2 = <INP2> ;	     	# This is 2. msgstr
		#
		# Split fields etc... already seen
		#
		$kartako = <INP0>;	# Original
		$ooline = <INP0>;	# Read OOo line
		@polja = split ( /\t/ , $ooline ) ;
		$polja[10] = clean_text ( $text1 ) ;
		$polja[13] = clean_text ( $text2 ) ;
		$index = 0 ;
		$polja[9] = "$target_lng" ;
		#
		# Put all fields in one line, separated with TABs 
		# (except the first one (index)!)
		#
		foreach $polje (@polja) {
			if ( $index == 0 ) {
				$output = $polje ;
			} else {
				$output .= "\t" . $polje ;
			} ;
			$index ++ ;
		}
		print ( "$kartako" );
		print ( "$output" ) ;
	}
#
# This wasn't the case in OOo 1.0.2 so I left this out.
# There's so much code anyway
#
	elsif ( "$our_comment" eq "A1B1" ) {
		print "\n";
		print "THIS SHOULD NOT HAPPEND IN THE OOo1.0 !!!!!!!!!\n";
		print "If it is a case in some newer versions, feel free\n";
		print "to add this piece of code and send me a message\n";
		print "\n";
	}
}
close INP0;
close INP2;




##### OLD STUFF, maybe sometime for help ###############

#		s/^\s+//g;
#		next if ( /^##/ );
#		next if ( $_ eq "" );

#	next if ( m/^[\s\n\r]*$/ );
#	next if ( /^##/ );
#	next if ( $_ eq "" );

